[leetcode] 115. Distinct Subsequences

网友投稿 299 2022-08-27

[leetcode] 115. Distinct Subsequences

Description

Given a string S and a string T, count the number of distinct subsequences of S which equals T.

A subsequence of a string is a new string which is formed from the original string by deleting some (can be none) of the characters without disturbing the relative positions of the remaining characters. (ie, “ACE” is a subsequence of “ABCDE” while “AEC” is not).

Example 1:

Input: S = "rabbbit", T = "rabbit"Output: 3Explanation:As shown below, there are 3 ways you can generate "rabbit" from S.(The caret symbol ^ means the chosen letters)rabbbit^^^^ ^^rabbbit^^ ^^^^rabbbit^^^ ^^^

Example 2:

Input: S = "babgbag", T = "bag"Output: 5Explanation:As shown below, there are 5 ways you can generate "bag" from S.(The caret symbol ^ means the chosen letters)babgbag^^ ^babgbag^^ ^babgbag^ ^^babgbag ^ ^^babgbag ^^^

分析

题目的意思是:给定字符串S和T,求S的子串等于T的数量。

动态规划,定义dp[i][j]为字符串i变换到j的变换方法。 如果S[i]==T[j],那么dp[i][j] = dp[i-1][j-1] + dp[i-1][j]。意思是:如果当前S[i]==T[j],那么当前这个字母即可以保留也可以抛弃, 所以变换方法等于保留这个字母的变换方法加上不用这个字母的变换方法。 如果S[i]!=T[i],那么dp[i][j] = dp[i-1][j],意思是如果当前字符不等,那么就只能抛弃当前这个字符。 递归公式中用到的dp[0][0] = 1,dp[i][0] = 0(把任意一个字符串变换为一个空串只有一个方法)

代码

class Solution {public: int numDistinct(string s, string t) { int m=s.length(); int n=t.length(); if(m> dp(m+1,vector(n+1,0)); for(int i=0;i<=m;i++){ for(int j=0;j<=n;j++){ if(i==0&&j==0){ dp[i][j]=1; }else if(i==0){ dp[i][j]=0; }else if(j==0){ dp[i][j]=1; }else{ if(s[i-1]==t[j-1]){ dp[i][j]=dp[i-1][j-1]+dp[i-1][j]; }else { dp[i][j]=dp[i-1][j]; } } } } return dp[m][n]; }};

参考文献

​​[编程题]distinct-subsequences​​​​Leetcode Distinct Subsequences 解题报告​​

版权声明:本文内容由网络用户投稿,版权归原作者所有,本站不拥有其著作权,亦不承担相应法律责任。如果您发现本站中有涉嫌抄袭或描述失实的内容,请联系我们jiasou666@gmail.com 处理,核实后本网站将在24小时内删除侵权内容。

上一篇:好的线上营销对于一个老板来讲意味着什么?(线上营销的含义)
下一篇:mac [oh-my-zsh] Insecure completion-dependent directories detected
相关文章

 发表评论

暂时没有评论,来抢沙发吧~